SignalRMVCChat/Models/MyAccount.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Newtonsoft.Json;
using SignalRMVCChat.Service;
using SignalRMVCChat.SysAdmin.Service;
using TelegramBotsWebApplication.Areas.Admin.Service;
using System.ComponentModel.DataAnnotations.Schema;
using SignalRMVCChat.Models.ET;
using SignalRMVCChat.Models.UsersSeparation;
using SignalRMVCChat.Models.TelegramBot;
using SignalRMVCChat.Models.Alarms;

namespace SignalRMVCChat.Models
{
    public class MyAccount : EntitySafeDelete, ISelfReferenceEntity<MyAccount>
    {
        public MyAccount()
        {
            TelegramBots = new List<TelegramBotSetting>();
            MyWebsites = new List<MyWebsite>();
            Chats = new List<Chat>();
            MySockets = new List<MySocket>();
            Children = new List<MyAccount>();
            MyAccountPlans = new List<MyAccountPlans>();
            MyAccountPayments = new List<MyAccountPayment>();
            Tags = new List<Tag>();
            Forms = new List<Form>();
            ReceivedPrivateChats = new List<ReceivedPrivateChat>();
            MyAccountType = MyAccountType.Normal;
            ChatAutomatics = new List<ChatAutomatic>();
            EventTriggers = new List<EventTrigger>();
            UsersSeparations = new List<UsersSeparation.UsersSeparation>();
            ReadyPms = new List<ReadyPm.ReadyPm>();
            RemindMes = new List<RemindMe.RemindMe>();
            Compaigns = new List<Compaign.Compaign>();
            Bots = new List<Bot.Bot>();
        }


        public MyAccountType MyAccountType { get; set; }

        public List<Tag> Tags { get; set; }

        public string IdentityUsername { get; set; }

        public string Username { get; set; }
        public string Password { get; set; }
        public OnlineStatus OnlineStatus { get; set; }
        public string Name { get; set; }
        public string Token { get; set; }

        public string AccessWebsitesJson { get; set; }

        [NotMapped]
        public int[] AccessWebsites
        {
            set { AccessWebsitesJson = JsonConvert.SerializeObject(value); }
            get
            {
                if (string.IsNullOrEmpty(AccessWebsitesJson))
                {
                    return new int[0];
                }

                return JsonConvert.DeserializeObject<int[]>(AccessWebsitesJson);
            }
        }

        public MyAccount Parent { get; set; }
        public int? ParentId { get; set; }
        public List<Chat> Chats { get; set; }

        public int TotalUnRead { get; set; }
        public PlanType PlanType { get; set; }

        //  public int TotalUnRead { get; set; }


        /// <summary>
        /// این مال کاستومر است در جایی لازم شد تا ابجکت دیگری تعریف نکنم 
        /// </summary>
        [NotMapped]
        public CustomerTrackInfo LastTrackInfo { get; set; }


        /// <summary>
        /// در هر اتصال یک ابجکت ایجاد می شود و یا از دیتابیس فراخوانی می شود اطلاعات اتصال
        /// </summary>
        [JsonIgnore]
        public List<MySocket> MySockets { get; set; }

        /// <summary>
        /// وب سایت هایی که ادمین ثبت کرده است
        /// یا اگر زیر مجموعه این ادمین باشد مثلا من صاحب سایتی هستم و یک ادمین دیگر برای آن تعریف کرده باشم
        /// در اینصورت زیر ادمین نیز به هرکدام از وب سایت ها که بخواهم می توانم وصل کرده و دسترسی بدهم
        /// </summary>
        public List<MyWebsite> MyWebsites { get; set; }


        public List<MyAccount> Children { get; set; }
        public List<MyAccountPlans> MyAccountPlans { get; set; }
        public List<MyAccountPayment> MyAccountPayments { get; set; }
        public List<ChatAutomatic> ChatAutomatics { get; set; }

        [NotMapped] public string Address { get; set; }

        [NotMapped] public Chat Message { get; set; }

        [NotMapped] public int NewMessageCount { get; set; }


        [NotMapped] public Chat LastMessage { get; set; }

        public int? ProfileImageId { get; set; }

        [NotMapped] public string Time { get; set; }

        // برای نمایش در سمت کلاینت
        [NotMapped] public IEnumerable<Tag> CustomerTags { get; set; }

        public Image ProfileImage { get; set; }


        public List<TelegramBotSetting> TelegramBots { get; internal set; }


        public string GetPlanTypeTranslate()
        {
            switch (PlanType)
            {
                case PlanType.Gold:
                    return "پلن طلایی";
                case PlanType.Silver:
                    return "پلن نقره ای";
                default:
                    return "پلن معمولی";
            }
        }

        public static string CalculateOnlineTime(DateTime argCreationDateTime)
        {
            var now = DateTime.Now;
            var seconds = (now - argCreationDateTime).TotalSeconds;
            var TotalMinutes = (now - argCreationDateTime).TotalMinutes;
            var TotalDays = (now - argCreationDateTime).TotalDays;
            var TotalHours = (now - argCreationDateTime).TotalHours;

            if (seconds < 60)
            {
                return Math.Round(seconds) + " ثانیه قبل ";
            }

            if (TotalMinutes < 60)
            {
                return Math.Round(TotalMinutes) + " دقیقه قبل ";
            }

            if (TotalHours < 24)
            {
                return Math.Round(TotalHours) + " ساعت قبل ";
            }

            if (TotalDays > 0)
            {
                return Math.Round(TotalDays) + "روز قبل";
            }

            return "ساعت تشخیص داده نشد";
        }

        public List<Form> Forms { get; set; }
        public bool HasRootPrivilages { get; set; }
        public string Email { get; set; }
        public string Phone { get; set; }
        public List<EventTrigger> EventTriggers { get; set; }
        public List<UsersSeparation.UsersSeparation> UsersSeparations { get; set; }

        [NotMapped] public List<UsersSeparationParam> UsersSeparationParams { get; set; }

        public List<RemindMe.RemindMe> RemindMes { get; set; }
        public List<ReadyPm.ReadyPm> ReadyPms { get; set; }


        public string ReceivedPrivateChatsJson { get; set; }

        [NotMapped]
        public List<ReceivedPrivateChat> ReceivedPrivateChats
        {
            set { ReceivedPrivateChatsJson = JsonConvert.SerializeObject(value); }
            get
            {
                if (string.IsNullOrEmpty(ReceivedPrivateChatsJson))
                {
                    return null;
                }

                return JsonConvert.DeserializeObject<List<ReceivedPrivateChat>>(ReceivedPrivateChatsJson);
            }
        }


        public string RemindMeFiresJson { get; set; }

        [NotMapped]
        public List<RemindMe.RemindMe> RemindMeFires
        {
            set { RemindMeFiresJson = JsonConvert.SerializeObject(value); }
            get
            {
                if (string.IsNullOrEmpty(RemindMeFiresJson))
                {
                    return null;
                }

                return JsonConvert.DeserializeObject<List<RemindMe.RemindMe>>(RemindMeFiresJson);
            }
        }

        public List<Models.Bot.Bot> Bots { get; set; }
        
        
        /// <summary>
        /// for showing data purposes 
        /// </summary>
        [NotMapped]
        public bool IsBlocked { get; set; }

        /// <summary>
        /// for showing data purposes 
        /// </summary>
        [NotMapped]
        public bool IsResolved { get; set; }

        public List<Models.Compaign.Compaign> Compaigns { get; set; }

        [NotMapped]
        public int? TelegramUserId { get;  set; }
        
        [NotMapped]
        public long TelegramChatId { get;  set; }
       
        [NotMapped]
        public LeaderBoardStatus LeaderBoardStatus { get;  set; }
        public bool IsNotificationMute { get;
            set; }
        public List<Alarm> Alarms { get;  set; }
    }

    public enum LeaderBoardStatus
    {
        NotChanged=1,Increased=2,Decreased=3
    }

    public class ReceivedPrivateChat
    {
        public ReceivedPrivateChat()
        {
            DateTime = DateTime.Now;
        }

        public Chat Chat { get; set; }
        public MyAccount SenderAdmin { get; set; }
        public Customer Customer { get; set; }


        public DateTime DateTime { get; set; } = DateTime.Now;

        public string Time
        {
            get { return MyAccount.CalculateOnlineTime(DateTime); }
        }
    }

    public enum PlanType
    {
        Trial,
        Silver,
        Gold
    }

    public enum MyAccountType
    {
        SystemMyAccount=7,
        Normal
    }
}

SignalRMVCChat/Areas/Customer/Controllers/MyAccountsController.cs
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web.Http.Results;
using System.Web.Mvc;
using SignalRMVCChat.Areas.security.Service;
using SignalRMVCChat.Areas.sysAdmin.Service;
using SignalRMVCChat.DependencyInjection;
using SignalRMVCChat.Models;
using SignalRMVCChat.Service;
using SignalRMVCChat.SysAdmin.Service;
using TelegramBotsWebApplication;
using TelegramBotsWebApplication.ActionFilters;
using TelegramBotsWebApplication.Areas.Admin.Controllers;
using TelegramBotsWebApplication.Areas.Admin.Models;

namespace SignalRMVCChat.Areas.Customer.Controllers
{
    [TelegramBotsWebApplication.ActionFilters.MyControllerFilter]
    [MyAuthorizeFilter]
    public class MyAccountsController : GenericController<MyAccount>
    {
        public MyAccountsController()
        {
            Service = Injector.Inject<MyAccountProviderService>();
        }
        protected override void OnException(ExceptionContext filterContext)
        {
            SignalRMVCChat.Models.MySpecificGlobal.OnControllerException(filterContext, ViewData);
        }

        [HttpPost]
        public ActionResult SaveSelectedWebsites(int myAccountId, int parentId, int[] selectedWebsites)
        {
            if (selectedWebsites == null)
            {
                throw new Exception("هیچ وب سایتی انتخاب نشده است");
            }

            var myAccountProviderService = Injector.Inject<MyAccountProviderService>();
            MyAccount currentUserAccount = myAccountProviderService.GetAccountIdByUsername(CurrentRequestSingleton
                .CurrentRequest.AppLoginViewModel
                .Username);

            if (currentUserAccount.Id != parentId)
            {
                throw new Exception("اکانت متعلق به شما نیست");
            }


            currentUserAccount = myAccountProviderService.LoadChildren(currentUserAccount);

            if (currentUserAccount.Children.Any(c => c.Id == myAccountId) == false)
            {
                throw new Exception("اکانت مورد ویرایش متعلق به شما نیست");
            }

            var childAccount = GetMyAccountWithChildren(myAccountId);
            var parent = GetMyAccountWithChildren(parentId);


            // اگر تعداد ارسالی با تعداد وجود داشته برابر نباشد یعنی یکی یا بیشتر وجود ندارد
            var myWebsiteService = Injector.Inject<MyWebsiteService>();
            var count = myWebsiteService.GetQuery()
                .Where(c => c.IsDeleted == false
                ).Count(c => selectedWebsites.Contains(c.Id));

            if (count != selectedWebsites.Length)
            {
                throw new Exception("وب سایت های انتخاب شده وجود ندارد");
            }


            childAccount.AccessWebsites = selectedWebsites;
            myAccountProviderService.VanillaSave(childAccount);
            myAccountProviderService.Save(childAccount);

            return new HttpStatusCodeResult(200);
        }

        [HttpPost]
        public ActionResult GetMyAccountWebsitesSelected(int myAccountId, int parentId)
        {
            var childrenWebsites = GetMyAccountWithAccessChildren(myAccountId);
            var parent = GetMyAccountWithChildren(parentId);

            return PartialView("ChildWebsiteList", new MyAccountViewModel
            {
                ChildId = myAccountId,
                childrenWebsites = childrenWebsites,
                Parent = parent
            });
        }

        private List<MyWebsite> GetMyAccountWithAccessChildren(int myAccountId)
        {
            var myAccountProviderService = Injector.Inject<MyAccountProviderService>();
            var account = myAccountProviderService.GetById(myAccountId);

            var myWebsiteService = Injector.Inject<MyWebsiteService>();

            var children = myWebsiteService.GetQuery()
                .Where(c => c.IsDeleted == false)
                .Where(c => account.Single.AccessWebsites.Contains(c.Id)).ToList();

            return children;
        }

        public MyAccount GetMyAccountWithChildren(int myAccountId)
        {
            var myAccountProviderService = Injector.Inject<MyAccountProviderService>();

            var myAccount = myAccountProviderService.GetQuery().Include(o => o.MyWebsites)
                .SingleOrDefault(o => o.Id == myAccountId);

            myAccount = myAccountProviderService.LoadChildren(myAccount);
            if (myAccount == null)
            {
                throw new Exception("اکانت یافت نشد");
            }

            return myAccount;
        }

        public ActionResult AssignWebsites()
        {
            try
            {
                var myAccountProviderService = Injector.Inject<MyAccountProviderService>();

                var myAccountId = myAccountProviderService.GetAccountIdByUsername(CurrentRequestSingleton.CurrentRequest
                    .AppLoginViewModel
                    .Username).Id;

                var myAccount = GetMyAccountWithChildren(myAccountId);

                return View("AssignWebsites", myAccount);
            }
            catch (Exception e)
            {SignalRMVCChat.Service.LogService.Log(e);
                TempData["err"] = MyGlobal.RecursiveExecptionMsg(e);
                return View("AssignWebsites", null);
            }
        }

        public override ActionResult Index(int? take, int? skip, int? dependId)
        {
            take = take ?? 20;
            MyDataTableResponse<MyAccount> response =
                (Service as MyAccountProviderService).GetAsPaging(SecurityService.GetCurrentUser().UserName);
            return View(response);
        }


        public override ActionResult Save(MyAccount model)
        {
            if (model.Id == 0)
            {
                PlanService.CheckSupporterCount();
            }

            return base.Save(model);
        }
    }

    public class MyAccountViewModel
    {
        public MyAccount Parent { get; set; }
        public int ChildId { get; set; }
        public List<MyWebsite> childrenWebsites { get; set; }
    }
}

SignalRMVCChat/Areas/Customer/Views/MyAccounts/AssignWebsites.cshtml
@using SignalRMVCChat.DependencyInjection
@using SignalRMVCChat.Service
@model SignalRMVCChat.Models.MyAccount

@{
    ViewBag.Title = "تخصیص ادمین های هر وب سایت";
    Layout = "~/Areas/Customer/Views/Shared/_Layout_Customer.cshtml";
}


<style>
    .sel:hover{
        background-color: aqua;
        cursor: pointer
    }
</style>



<div class="card">
    <div class="card-header">
        <h5>@ViewBag.Title </h5>
    </div>
    <div class="card-block">

        @{
            if (Model?.MyWebsites?.Count == 0)
            {
                <p>هیچ وب سایتی تعریف نکرده اید برای شروع اولین وب سایت را ایجاد نمایید</p>
                <a href="/customer/Mywebsites/Detail?id=0">تعریف وب سایت</a>
            }


        }


        <div class="alert alert-danger" id="err" style="display: none"></div>
        <div class="alert alert-success" id="msg" style="display: none"></div>

        @if (Model?.MyWebsites != null)
        {


        
            <div class="">
                <p>لطفا ابتدا ادمینی که میخواهید به او دسترسی بدهید انتخاب نمایید</p>
                <div class="col-md-6">
                    <table class="table">
                        <thead>

                        <tr>
                            <th style="text-align: center">لیست ادمین ها</th>
                        </tr>

                        <tr>
                            <th>نام کاربری</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach (var web in Model.Children)
                        {
                            <tr class="sel" onclick="selectChildMyAccount(@web.Id, @Model.Id)">
                                <td>@web.Username</td>
                            </tr>
                        }


                        </tbody>
                    </table>
                </div>
                <div class="col-md-6">
                    <div id="selectList"></div>
                </div>

            </div>


        }
        
        <br/>
        <div class="col-md-2 " style="display: none" id="submitButton">

            <button class="btn btn-primary" onclick="Mysubmit()">ثبت</button>
        </div>


        @section scripts{
            <script>
                function showError(text) {
                    $('#msg').hide();
                    $('#err').show();
                    $('#err').html(text);
                }

                function showSuccess(text) {
                    $('#err').hide();
                    $('#msg').show();
                    $('#msg').text(text);
                }

                function Mysubmit() {

                    var selected = $('.websiteSelected');
                    if (!selected || !selected.length) {
                        showError('هیچ وبسایتی انتخاب نشده است');
                        return;
                    }
                    if (!window['myaccountId']) {
                        showError('هیچ ادمینی انتخاب نشده است');
                        return;
                    }
                    if (!window['parent']) {
                        showError('ریشه انتخاب نشده است');
                        return;
                    }
                    let arr = [];
                    for (var i = 0; i < selected.length; i++) {
                        let val = $(selected[i]).val();
                        arr.push(val);
                    }
                    $('#submitButton button').prop('disabled',true);


                    $.ajax({
                        url: '/customer/MyAccounts/SaveSelectedWebsites',
                        data: {
                            selectedWebsites: arr,
                            parentId: window['parent'],
                            myaccountId: window['myaccountId'],
                        },
                        method: 'post',
                        success: function (res) {
                            $('#submitButton button').prop('disabled',false);

                            showSuccess("با موفقیت ثبت شد");
                        },
                        error: function (err) {
                            $('#submitButton button').prop('disabled', false);

                            console.error(err);
                            showError('خطایی رخ داد' + err.responseText);
                        }

                    })
                }

                function selectChildMyAccount(myaccountId, parent) {
                    window['myaccountId'] = myaccountId;
                    window['parent'] = parent;

                    

                    ajaxCallFill('/Customer/MyAccounts/GetMyAccountWebsitesSelected','#selectList', { myAccountId: myaccountId, parentId: parent });
                }

                function ajaxCallFill(url, target, body) {

                    $.ajax({
                        url: url,
                        data: body,
                        method: 'post',
                        success: function (res) {
                            $(target).html(res);

                            $('#submitButton').show();
                        },
                        error: function (err) {

                            console.error(err);
                            showError('خطایی رخ داد' + err.responseText);
                        }

                    })
                }
            </script>
        }

    </div>
</div>

SignalRMVCChat/Areas/Customer/Views/MyAccounts/ChildWebsiteList.cshtml
@model SignalRMVCChat.Areas.Customer.Controllers.MyAccountViewModel

@{
    Layout = null;
}


<table class="table">
    <thead>
    <tr>
        <th>انتخاب</th>
        <th>آدرس وب سایت</th>
    </tr>
    </thead>
    <tbody>
    @{
        if (Model?.Parent?.MyWebsites.Count==0)
        {
            <p>هیچ وب سایتی تعریف نشده است</p>
        }
        foreach (var parentMyWebsite in Model?.Parent?.MyWebsites)
        {
            bool hasWebsite = false;
            if (Model?.childrenWebsites?.Count > 0)
            {
                hasWebsite = Model?.childrenWebsites?
                .Any(c => c.Id == parentMyWebsite.Id) ?? false;
            }
            int childId=Model?.ChildId ?? 0;
            <tr>
                <td>
                    @if (hasWebsite)
                    {
                        <input myaccountid="@childId" class="websiteSelected" checked="checked" type="checkbox" name="selectedWebsite" value="@parentMyWebsite.Id" />
                    }
                    else
                    {
                        <input myaccountid="@childId"  class="websiteSelected"  type="checkbox" name="selectedWebsite" value="@parentMyWebsite.Id"/>
                    }
                </td>
                <td>@parentMyWebsite.BaseUrl</td>
            </tr>
        }
           
        }

    </tbody>
</table>

SignalRMVCChat/Areas/Customer/Views/MyAccounts/Detail.cshtml
@using SignalRMVCChat.Areas.security.Service
@using SignalRMVCChat.DependencyInjection
@using SignalRMVCChat.Models
@using SignalRMVCChat.Service
@model TelegramBotsWebApplication.Areas.Admin.Models.MyEntityResponse<MyAccount>

@{
    ViewBag.Title = "در این قسمت ادمین پشتیبانی تعریف می نمایید :";
    Layout = "../../Views/Shared/_Layout_Customer.cshtml";


    var myAccountProviderService = Injector.Inject<MyAccountProviderService>();
    MyAccount myAccount = myAccountProviderService.GetAccountIdByUsername(SecurityService.GetCurrentUser().UserName);
}


@{

    Plan plan = MyAccountProviderService.GetCurrentPlan();
}

@{

    try
    {

        if (Model.Single.Id == 0)
        {
            Model.Single.HasRootPrivilages = true;
        }

        PlanService.CheckSupporterCount();
    }
    catch (PlanException e)
    {
        <div class="alert alert-danger">@e.Message</div>
    }
}


<div class="card">
    <div class="card-header">
        <h5>@ViewBag.Title </h5>
    </div>
    <div class="card-block">


        @using (Html.BeginForm("Save", "MyAccounts", FormMethod.Post))
        {
            @Html.ValidationSummary("", new { @class = "text-danger" })

            <label>
                نام
            </label>
            <input value="@Model.Single.Name"
                   style="width: 100%;text-align: left;direction: ltr" name="Name" />


            <label>
                نام کاربری ادمین
            </label>
            <input value="@Model.Single.Username"
                   style="width: 100%;text-align: left;direction: ltr" name="Username" />

            <label>
                رمز عبور ادمین
            </label>
            <input value="@Model.Single.Password"
                   style="width: 100%;text-align: left;direction: ltr" name="Password" />

            @Html.Hidden("Id", myAccount.Id)



            <label>دسترسی root</label>
            @Html.CheckBox("HasRootPrivilages", myAccount.HasRootPrivilages)

            <hr />

            <input type="submit" value="ثبت" class="btn btn-primary" />



        }


    </div>
</div>

SignalRMVCChat/Areas/Customer/Views/MyAccounts/Index.cshtml
@model TelegramBotsWebApplication.Areas.Admin.Models.MyDataTableResponse<SignalRMVCChat.Models.MyAccount>

@{
    ViewBag.Title = "ادمین های من";
    Layout = "../../Views/Shared/_Layout_Customer.cshtml";
}
<style>
    
th{
    text-align: right !important;
    direction: rtl!important;
}
</style>

<div class="card">
                                                    <div class="card-header">
                                                        <h5>@ViewBag.Title </h5>
                                                    </div>
<div class="card-block">
                                                       


       <p>با تعریف نام کاربری و رمز عبور می توانید به تعداد دلخواه ادمین تعریف کرده و برای پشتیبانی وب سایت خود استفاده نمایید</p>
 <a href="/customer/MyAccounts/Detail?id=0">تعریف ادمین جدید</a>
    
    @if (Model.EntityList!=null && Model.EntityList.Count > 0)
    {
    <table class="table">
        <thead>

        <tr>
            <th>نام و نام خانوادگی</th>
            <th>نام کاربری</th>
            <th>رمز عبور</th>
            <th>دسترسی به وب سایت ها</th>
            <th colspan="3"></th>

        </tr>
        </thead>
        <tbody>
        @foreach (var rec in Model.EntityList)
        {
            <tr>
                <td>@rec.Name</td>
                <td>@rec.Username</td>
                <td>@rec.Password</td>
                <td>

                    <a href="/customer/MyAccounts/AssignWebsites">دسترسی ها</a>
                </td>
                <td><form method="post" action="/Customer/MyAccounts/Delete?id=@rec.Id">
                     
                    <input hidden="hidden" name="Id" value="@rec.Id"/>
                     
                    <button type="submit" class="btn btn-danger">حذف</button>
                </form></td>
                <td>
                    
                    <a href="/customer/MyAccounts/Detail?id=@rec.Id">ویرایش</a>
                </td>
            </tr>
        }
        </tbody>
    </table>

    }
    else
    {
        <p>در حال حاضر هیچ ادمینی ثبت نشده است برای شروع یک ادمین <a href="/customer/MyAccounts/Detail?id=0">ایجاد</a> تعریف نمایید</p>
    }
    
</div>
</div>